## org.apache.mahout.math
Class MatrixVectorView

    java.lang.Object
      org.apache.mahout.math.AbstractVector
          org.apache.mahout.math.MatrixVectorView

All Implemented Interfaces:
  java.lang.Cloneable, java.lang.Iterable<Vector.Element>, Vector

    public class MatrixVectorView

extends AbstractVector

Provides a virtual vector that is really a row or column or diagonal of a matrix.

Nested Class Summary

Nested classes/interfaces inherited from class org.apache.mahout.math.AbstractVector
`AbstractVector.LocalElement`

Nested classes/interfaces inherited from interface org.apache.mahout.math.Vector
`Vector.Element`

Field Summary

Fields inherited from class org.apache.mahout.math.AbstractVector
`lengthSquared`

Constructor Summary
`MatrixVectorView(Matrix matrix, int row, int column, int rowStride, int columnStride)`

Method Summary
`Vector` `clone()` Return a copy of the recipient
`int` `getNumNondefaultElements()` Return the number of values in the recipient
`double` `getQuick(int index)` Return the value at the given index, without checking bounds
`boolean` `isDense()`
`boolean` `isSequentialAccess()`
`java.util.Iterator<Vector.Element>` `iterateNonZero()` Iterates over all non-zero elements.
`java.util.Iterator<Vector.Element>` `iterator()` Iterates over all elements * NOTE: Implementations may choose to reuse the Element returned for performance reasons, so if you need a copy of it, you should call `AbstractVector.getElement(int)` for the given index
`Vector` `like()` Return an empty vector of the same underlying class as the receiver
`protected Matrix` `matrixLike(int rows, int columns)` Subclasses must override to return an appropriately sparse or dense result
`void` `setQuick(int index, double value)` Set the value at the given index, without checking bounds

Methods inherited from class org.apache.mahout.math.AbstractVector
`addTo, aggregate, aggregate, asFormatString, assign, assign, assign, assign, assign, assign, cross, decodeVector, divide, dot, dotSelf, equals, get, getDistanceSquared, getElement, getLengthSquared, hashCode, logNormalize, logNormalize, logNormalize, maxValue, maxValueIndex, minus, minValue, minValueIndex, norm, normalize, normalize, plus, plus, set, size, times, times, toString, viewPart, zSum`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### MatrixVectorView

    public MatrixVectorView(Matrix matrix,
                            int row,
                            int column,
                            int rowStride,
                            int columnStride)

Method Detail

### isDense

    public boolean isDense()

  Returns:
    true iff the `Vector` implementation should be considered dense -- that it explicitly represents every value

### isSequentialAccess

    public boolean isSequentialAccess()

  Returns:
    true iff `Vector` should be considered to be iterable in index order in an efficient way. In particular this implies that `iterator()` and `iterateNonZero()` return elements in ascending order by index.

### iterator

    public java.util.Iterator<Vector.Element> iterator()

  Iterates over all elements

  * NOTE: Implementations may choose to reuse the Element returned for performance reasons, so if you need a copy of it, you should call `AbstractVector.getElement(int)` for the given index

  Returns:
    An `Iterator` over all elements

### iterateNonZero

    public java.util.Iterator<Vector.Element> iterateNonZero()

  Iterates over all non-zero elements.

  NOTE: Implementations may choose to reuse the Element returned for performance reasons, so if you need a copy of it, you should call `AbstractVector.getElement(int)` for the given index

  Returns:
    An `Iterator` over all non-zero elements

### getQuick

    public double getQuick(int index)

  Return the value at the given index, without checking bounds

  Parameters:
    `index` - an int index
  Returns:
    the double at the index

### like

    public Vector like()

  Return an empty vector of the same underlying class as the receiver

  Returns:
    a Vector

### setQuick

    public void setQuick(int index,
                         double value)

  Set the value at the given index, without checking bounds

  Parameters:
    `index` - an int index into the receiver
    `value` - a double value to set

### getNumNondefaultElements

    public int getNumNondefaultElements()

  Return the number of values in the recipient

  Returns:
    an int

### matrixLike

    protected Matrix matrixLike(int rows,
                                int columns)

  Subclasses must override to return an appropriately sparse or dense result

  Specified by:
    `matrixLike` in class `AbstractVector`
  Parameters:
    `rows` - the row cardinality
    `columns` - the column cardinality
  Returns:
    a Matrix

### clone

    public Vector clone()

  Description copied from interface: `Vector`
  Return a copy of the recipient

  Specified by:
    `clone` in interface `Vector`
  Overrides:
    `clone` in class `AbstractVector`
  Returns:
    a new Vector

Copyright © 2008-2010 The Apache Software Foundation. All Rights Reserved.